k_cos.c File Reference
`#include "math_libm.h"`
`#include "math_private.h"`
Include dependency graph for k_cos.c:

Go to the source code of this file.

## Functions

double attribute_hidden | __kernel_cos (double x, double y)

## Variables

static double | one = 1.00000000000000000000e+00
static double | C1 = 4.16666666666666019037e-02
static double | C2 = -1.38888888888741095749e-03
static double | C3 = 2.48015872894767294178e-05
static double | C4 = -2.75573143513906633035e-07
static double | C5 = 2.08757232129817482790e-09
static double | C6 = -1.13596475577881948265e-11

## Function Documentation

double attribute_hidden __kernel_cos | ( | double | x,
|  | double | y
| ) |  |

Definition at line 74 of file k_cos.c.

References C1, C2, C3, C4, C5, C6, GET_HIGH_WORD, INSERT_WORDS, and one.

Referenced by libm_hidden_proto().

{
double a, hz, z, r, qx;
int32_t ix;
GET_HIGH_WORD(ix, x);
ix &= 0x7fffffff; /* ix = |x|'s high word */
if (ix < 0x3e400000) { /* if x < 2**27 */
if (((int) x) == 0)
return one; /* generate inexact */
}
z = x * x;
r = z * (C1 + z * (C2 + z * (C3 + z * (C4 + z * (C5 + z * C6)))));
if (ix < 0x3FD33333) /* if |x| < 0.3 */
return one - (0.5 * z - (z * r - x * y));
else {
if (ix > 0x3fe90000) { /* x > 0.78125 */
qx = 0.28125;
} else {
INSERT_WORDS(qx, ix - 0x00200000, 0); /* x/4 */
}
hz = 0.5 * z - qx;
a = one - qx;
return a - (hz - (z * r - x * y));
}
}
GET_HIGH_WORD
#define GET_HIGH_WORD(i, d)
Definition: math_private.h:103
r
GLdouble GLdouble GLdouble r
Definition: SDL_opengl.h:2072
int32_t
signed int int32_t
Definition: SDL_config_windows.h:61
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1567
one
static double one
Definition: k_cos.c:61
C2
static double C2
Definition: k_cos.c:63
C5
static double C5
Definition: k_cos.c:66
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1567
C4
static double C4
Definition: k_cos.c:65
INSERT_WORDS
#define INSERT_WORDS(d, ix0, ix1)
Definition: math_private.h:121
C3
static double C3
Definition: k_cos.c:64
C6
static double C6
Definition: k_cos.c:67
z
GLdouble GLdouble z
Definition: SDL_opengl_glext.h:404
C1
static double C1
Definition: k_cos.c:62
a
GLboolean GLboolean GLboolean GLboolean a
Definition: SDL_opengl_glext.h:1109

## Variable Documentation

double C1 = 4.16666666666666019037e-02

static

Definition at line 62 of file k_cos.c.

Referenced by __kernel_cos().

double C2 = -1.38888888888741095749e-03

static

Definition at line 63 of file k_cos.c.

Referenced by __kernel_cos().

double C3 = 2.48015872894767294178e-05

static

Definition at line 64 of file k_cos.c.

Referenced by __kernel_cos().

double C4 = -2.75573143513906633035e-07

static

Definition at line 65 of file k_cos.c.

Referenced by __kernel_cos().

double C5 = 2.08757232129817482790e-09

static

Definition at line 66 of file k_cos.c.

Referenced by __kernel_cos().

double C6 = -1.13596475577881948265e-11

static

Definition at line 67 of file k_cos.c.

Referenced by __kernel_cos().

double one = 1.00000000000000000000e+00

static

Definition at line 61 of file k_cos.c.

Referenced by __kernel_cos().